; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive
  
;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\msvcrt.inc
      include \masm32\macros\macros.asm

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\msvcrt.lib

      include \masm32\include\dialogs.inc

      DlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD 

      alt_timer PROTO :DWORD,:DWORD,:DWORD,:DWORD
      alt_timer_thread PROTO :DWORD

    .data?
      hWnd      dd ?
      hInstance dd ?
      counter   dd ?
      IDthread  dd ?

    .code

; 

start:
  
      mov hInstance, FUNC(GetModuleHandle,NULL)

      call main

      invoke ExitProcess,eax

; 

main proc

    Dialog "Blank Dialog", \                ; caption
           "MS Sans Serif",10, \            ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            3, \                            ; number of controls
            50,50,155,100, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgButton "Start Timer",WS_TABSTOP,106,5,40,13,IDOK
    DlgButton "Stop Timer",WS_TABSTOP,106,20,40,13,1000
    DlgButton "Cancel",WS_TABSTOP,106,35,40,13,IDCANCEL

    CallModalDialog hInstance,0,DlgProc,NULL

    ret

main endp

; 

DlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
 
    Switch uMsg
      Case WM_INITDIALOG
        invoke SendMessage,hWin,WM_SETICON,1,
                           FUNC(LoadIcon,NULL,IDI_ASTERISK)
        m2m hWnd, hWin
        return 1
      Case WM_COMMAND
        Switch wParam
          Case IDOK
            mov counter, 0
            mov IDthread, rv(alt_timer,1000,1100,WM_COMMAND,hWin)

          case 1000
            invoke PostThreadMessage,IDthread,WM_CLOSE,0,0
            mov counter, 0
            invoke SetWindowText,hWin,str$(counter)

          case 1100
            add counter, 1
            invoke SetWindowText,hWin,str$(counter)

          Case IDCANCEL
            jmp quit_dialog
        EndSw
      Case WM_CLOSE
        quit_dialog:
         invoke EndDialog,hWin,0
    EndSw

    return 0

DlgProc endp

; 

alt_timer proc interval:DWORD,idm:DWORD,retmsg:DWORD,hParent:DWORD

    LOCAL idnum     :DWORD
    LOCAL argarr[4] :DWORD

    push esi

    lea esi, argarr
    m2m [esi], interval
    m2m [esi+4], idm
    m2m [esi+8], retmsg
    m2m [esi+12], hParent

    invoke CreateThread,NULL,NULL,
                        ADDR alt_timer_thread,  ; thread address
                        ADDR argarr,            ; array address
                        NULL,ADDR idnum         ; thread return ID

    mov eax, idnum

    pop esi

    ret

alt_timer endp

; 

alt_timer_thread proc args:DWORD

    LOCAL interval  :DWORD
    LOCAL idm       :DWORD
    LOCAL retmsg    :DWORD
    LOCAL hParent   :DWORD
    LOCAL tmsg      :MSG

    push esi

    mov esi, args
    mov eax, [esi]
    mov interval, eax
    mov eax, [esi+4]
    mov idm, eax
    mov eax, [esi+8]
    mov retmsg, eax
    mov eax, [esi+12]
    mov hParent, eax

    invoke PeekMessage,ADDR tmsg,NULL,WM_USER,WM_USER,PM_NOREMOVE 

  @@:
    invoke Sleep,interval
    invoke PeekMessage,ADDR tmsg,NULL,WM_CLOSE,WM_CLOSE,PM_NOREMOVE
    test eax, eax
    jnz @F
    invoke SendMessage,hParent,retmsg,idm,0
    jmp @B

  @@:
    invoke ExitThread,0

    pop esi

    ret

alt_timer_thread endp

; 

end start
